#ifndef LBXIMG_H_
#define LBXIMG_H_

#include <stdio.h>

typedef struct lbx_image LBXimg;
struct lbx_file_ops;

struct lbx_colour {
	unsigned char red;
	unsigned char green;
	unsigned char blue;
	unsigned char active;
};

struct lbx_imginfo {
	unsigned short width, height;
	unsigned char  nframes, loopstart, chunk;
	int palettesz, looping;
};

LBXimg *lbximg_open(void *f, const struct lbx_file_ops *fops,
                     int (*destructor)(void *));
LBXimg *lbximg_fopen(const char *file);
int     lbximg_close(LBXimg *img);

unsigned char **lbximg_getframe(LBXimg *img, int frame);
unsigned char **lbximg_getmask(LBXimg *img);

int lbximg_loadpalette(void *f, const struct lbx_file_ops *fops,
                       struct lbx_colour palette[static 256]);
int lbximg_getpalette(LBXimg *img, struct lbx_colour palette[static 256]);

void lbximg_getinfo(LBXimg *img, struct lbx_imginfo *info);

#endif
